<?php

add_action('wooznd_giftcard_before_sendcard', 'wznd_giftcard_before_sendcard', 10, 2);

function wznd_giftcard_before_sendcard($giftcard_id, $coupon_id) {
    global $giftcard;
    $giftcard = WooZndGiftCardDB::GetGiftCard($giftcard_id);
    $subject = WooZndUtil::GetOption('giftcard_sendtofriend_subject', 'You have recieved a gift card from [wznd_fromname]');
    $message = '';

    if (isset($giftcard['email_template_id']) && $giftcard['email_template_id'] > 0) {
        $pst_content = get_post($giftcard['email_template_id'])->post_content;
        $pst_style = get_post_meta($giftcard['email_template_id'], '_wznd_giftcard_custom_css', true);
        $message = (isset($css_styles) ? '<style>' . $pst_style . '</style>' : '') . $pst_content;
    }


    if (empty($message)) {
        $message = WooZndUtil::GetOption('giftcard_sendtofriend_message', 'Hi [wznd_toname], <br /> You have recieved a gift card from [wznd_fromname] with message <strong>[wznd_message]</strong> <br /> your gift card code is [wznd_coupon] and the value of this gift card is [wznd_amount]. please redeem your gift card at  [wznd_site_link] before its expiry date on [wznd_expirydate].');
    }
    $attach = WooZndUtil::GetOption('giftcard_sendtofriend_attach_pdf', 'yes');

    $attachments = array();
    if ($attach == 'yes') {
        $attachments = array(WP_CONTENT_DIR . '/uploads/woo-smart-pack/giftcards/giftcard' . $giftcard['id'] . '.pdf');
    }
    WooZndUtil::SendMail($giftcard['to_email'], do_shortcode($subject), do_shortcode($message), $attachments);
}

//add_action('wooznd_giftcard_after_sendcard', 'wznd_giftcard_after_sendcard', 10, 2);
//
//function wznd_giftcard_after_sendcard($giftcard_id, $coupon_id) {
//    global $giftcard;
//    $giftcard = WooZndGiftCardDB::GetGiftCard($giftcard_id);
//}

add_action('wooznd_giftcard_refunded', 'wznd_giftcard_refunded', 10, 3);

function wznd_giftcard_refunded($transaction_id, $giftcard_id, $coupon_id) {
    global $giftcard, $transaction;
    $giftcard = WooZndGiftCardDB::GetGiftCard($giftcard_id);
    $transaction = WooZndWalletTransactionDB::GetTransaction($transaction_id);

    $refund_mode = WooZndUtil::GetOption('giftcard_refund_mode', 'auto');

    $subject = WooZndUtil::GetOption('giftcard_refund_subject', 'Your gift card balance has being refunded');
    $message = WooZndUtil::GetOption('giftcard_refund_message', 'Hi [wznd_wallet_name], <br /> Your gift card <strong>[wznd_coupon]</strong> remaining balance <strong>[wznd_amount]</strong> has been refunded to you wallet <strong>[wznd_wallet_number]</strong>. You can use this money to purchase item at [wznd_site_link] any time.');

    $to = $giftcard['to_email'];
    if ($giftcard['status'] != ZND_GIFTCARD_STATUS_PENDING && $refund_mode == 'auto') {
        $to = $giftcard['from_email'];
    }
    WooZndUtil::SendMail($to, do_shortcode($subject), do_shortcode($message));
}
