<?php
add_filter('product_type_options', 'wooznd_gift_card_product_option');

function wooznd_gift_card_product_option($product_type_options) {
//    if (WooZndUtil::GetOption('enable_giftcard', 'yes') == 'no') {
//        return $product_type_options;
//    }
    $product_type_options['wznd_enable_giftcard'] = array(
        'id' => '_wznd_enable_giftcard',
        'wrapper_class' => 'show_if_simple show_if_variable',
        'label' => __('Gift Card', 'woocommerce-zc-giftcard'),
        'description' => __('Turn this product into gift product.', 'woocommerce-zc-giftcard'),
        'default' => 'no'
    );
    return $product_type_options;
}

add_filter('woocommerce_product_data_tabs', 'wooznd_giftcard_product_tabs');

function wooznd_giftcard_product_tabs($tabs) {
//    if (WooZndUtil::GetOption('enable_giftcard', 'yes') == 'no') {
//        return $tabs;
//    }
    $tabs['wznd_giftcard'] = array(
        'label' => __('Gift Card', 'woocommerce-zc-giftcard'),
        'target' => 'wznd_giftcard_options',
        'class' => array('show_if_simple', 'show_if_variable'),
    );
    return $tabs;
}

add_action('woocommerce_product_data_panels', 'wooznd_giftcard_options_product_tab_content', 99);

function wooznd_giftcard_options_product_tab_content() {
    global $post;
//    if (WooZndUtil::GetOption('enable_giftcard', 'yes') == 'no') {
//        return;
//    }
    ?><div id='wznd_giftcard_options' class='panel woocommerce_options_panel'>
        <div class='options_group'><?php
            //print_r(wc_get_coupon_types());
      //  print_r($args);
            wp_nonce_field(basename(__FILE__), 'wznd_giftcard_nonce');
            woocommerce_wp_select(
                    array(
                        'id' => '_wznd_giftcard_discount_type',
                        'label' => __('Discount Type', 'woocommerce-zc-giftcard'),
                        'class' => 'wc-enhanced-select',
                        'style' => 'width:60%',
                        'options' => array(
                            '' => __('Default', 'woocommerce-zc-giftcard'),
                            'fixed_cart' => __('Cart Discount', 'woocommerce-zc-giftcard'),
                            // 'percent' => __('Cart % Discount', 'woocommerce-zc-giftcard'),
                            'fixed_product' => __('Product Discount', 'woocommerce-zc-giftcard'),
                        //'percent_product' => __('Product % Discount', 'woocommerce-zc-giftcard'),
                        ),
                        'desc_tip' => true,
                        'description' => __('Controls gift card discount type.', 'woocommerce-zc-giftcard')
                    )
            );
            ?>
        </div><div class='options_group'><?php
            //print_r(wc_get_coupon_types());
            wp_nonce_field(basename(__FILE__), 'wznd_giftcard_nonce');
            woocommerce_wp_select(
                    array(
                        'id' => '_wznd_giftcard_price_type',
                        'label' => __('Pricing Type', 'woocommerce-zc-giftcard'),
                        'class' => 'wc-enhanced-select',
                        'style' => 'width:60%',
                        'options' => array(
                            'default' => __('Sales or Regular Price', 'woocommerce-zc-giftcard'),
                            'user' => __('User Price', 'woocommerce-zc-giftcard'),
                            'range' => __('Price Range', 'woocommerce-zc-giftcard'),
                            'select' => __('Price Selection', 'woocommerce-zc-giftcard')
                        ),
                        'desc_tip' => true,
                        'description' => __('Controls gift card pricing type.', 'woocommerce-zc-giftcard')
                    )
            );
            ?>
        </div>
        <div class='options_group show_if_price_range'>
            <?php
            woocommerce_wp_text_input(array(
                'id' => '_wznd_giftcard_from_price',
                'label' => __('Price Minimun', 'woocommerce-zc-giftcard'),
                'style' => 'width:60%',
                'desc_tip' => true,
                'description' => __('Controls minimun price range for price range.', 'woocommerce-zc-giftcard'),
                'type' => 'number',
                'data_type' => 'price',
                'placeholder' => '0.00',
                'custom_attributes' => array(
                    'min' => '0',
                    'step' => '0.01',
                )
            ));
            woocommerce_wp_text_input(array(
                'id' => '_wznd_giftcard_to_price',
                'label' => __('Price Maximun', 'woocommerce-zc-giftcard'),
                'style' => 'width:60%',
                'desc_tip' => true,
                'description' => __('Controls maximun price range for price range.', 'woocommerce-zc-giftcard'),
                'type' => 'number',
                'data_type' => 'price',
                'placeholder' => '0.00',
                'custom_attributes' => array(
                    'min' => '0',
                    'step' => '0.01',
                )
            ));
            ?>
        </div>
        <div class='options_group show_if_price_select'>
            <?php
            woocommerce_wp_textarea_input(
                    array(
                        'id' => '_wznd_giftcard_select_price',
                        'label' => __('Price Select Options', 'woocommerce-zc-giftcard'),
                        'style' => 'width:60%',
                        'placeholder' => '5|10|20',
                        'desc_tip' => true,
                        'description' => __('Controls price selection options.', 'woocommerce-zc-giftcard')
                    )
            );
            ?>
        </div>
        <div class="options_group">
            <?php
            woocommerce_wp_text_input(array(
                'id' => '_wznd_giftcard_expiry_days',
                'label' => __('Gift card validity (Days)', 'woocommerce-zc-giftcard'),
                'style' => 'width:60%',
                'default' => '7',
                'desc_tip' => true,
                'description' => __('Gift card validity period in days.', 'woocommerce-zc-giftcard'),
                'type' => 'number',
                'placeholder' => '07',
                'custom_attributes' => array(
                    'min' => '1',
                    'step' => '1',
                )
            ));
            ?>
        </div>
        <div class='options_group'>
            <?php
            $woo_ver = WC()->version;
            if ($woo_ver < "3.0.0" && $woo_ver < "2.7.0") {
                woocommerce_wp_text_input(array(
                    'id' => '_wznd_giftcard_product_ids',
                    'label' => __('Products', 'woocommerce-zc-giftcard'),
                    'style' => 'width:60%',
                    'desc_tip' => true,
                    'description' => __('Products which need to be in the cart to use this gift card or, for "Product Discounts", which products are discounted.', 'woocommerce-zc-giftcard'),
                    'class' => 'wc-product-search',
                    'custom_attributes' => array(
                        'data-multiple' => 'true',
                        'data-placeholder' => __('Search for a product&hellip;', 'woocommerce-zc-giftcard'),
                        'data-action' => 'woocommerce_json_search_products_and_variations',
                        'data-selected' => WooZndUtil::GetFormattedProductName(get_post_meta($post->ID, '_wznd_giftcard_product_ids', true)),
                    )
                ));

                woocommerce_wp_text_input(array(
                    'id' => '_wznd_giftcard_exclude_product_ids',
                    'label' => __('Exclude Products', 'woocommerce-zc-giftcard'),
                    'style' => 'width:60%',
                    'desc_tip' => true,
                    'description' => __('Products which must not be in the cart to use this gift card or, for "Product Discounts", which products are not discounted.', 'woocommerce-zc-giftcard'),
                    'class' => 'wc-product-search',
                    'custom_attributes' => array(
                        'data-multiple' => 'true',
                        'data-placeholder' => __('Search for a product&hellip;', 'woocommerce-zc-giftcard'),
                        'data-action' => 'woocommerce_json_search_products_and_variations',
                        'data-selected' => WooZndUtil::GetFormattedProductName(get_post_meta($post->ID, '_wznd_giftcard_exclude_product_ids', true)),
                    )
                ));
            } else {
                ?>
                <p class="form-field"><label><?php _e('Products', 'woocommerce-zc-giftcard'); ?></label>
                    <select class="wc-product-search" multiple="multiple" style="width: 60%;" name="_wznd_giftcard_product_ids[]" data-placeholder="<?php esc_attr_e('Search for a product&hellip;', 'woocommerce-zc-giftcard'); ?>" data-action="woocommerce_json_search_products_and_variations">
                        <?php
                        $product_ids = get_post_meta($post->ID, '_wznd_giftcard_product_ids', true);

                        foreach ($product_ids as $product_id) {
                            $product = wc_get_product($product_id);
                            if (is_object($product)) {
                                echo '<option value="' . esc_attr($product_id) . '"' . selected(true, true, false) . '>' . wp_kses_post($product->get_formatted_name()) . '</option>';
                            }
                        }
                        ?>
                    </select> <?php echo wc_help_tip(__('Products which need to be in the cart to use this gift card or, for "Product Discounts", which products are discounted.', 'woocommerce-zc-giftcard')); ?></p>
                <?php
                ?>
                <p class="form-field"><label><?php _e('Exclude Products', 'woocommerce-zc-giftcard'); ?></label>
                    <select class="wc-product-search" multiple="multiple" style="width: 60%;" name="_wznd_giftcard_exclude_product_ids[]" data-placeholder="<?php esc_attr_e('Search for a product&hellip;', 'woocommerce-zc-giftcard'); ?>" data-action="woocommerce_json_search_products_and_variations">
                        <?php
                        $product_ids = get_post_meta($post->ID, '_wznd_giftcard_exclude_product_ids', true);

                        foreach ($product_ids as $product_id) {
                            $product = wc_get_product($product_id);
                            if (is_object($product)) {
                                echo '<option value="' . esc_attr($product_id) . '"' . selected(true, true, false) . '>' . wp_kses_post($product->get_formatted_name()) . '</option>';
                            }
                        }
                        ?>
                    </select> <?php echo wc_help_tip(__('Products which must not be in the cart to use this gift card or, for "Product Discounts", which products are not discounted.', 'woocommerce-zc-giftcard')); ?></p>
                <?php
            }
            ?>
        </div>
        <div class='options_group'>
            <p class="form-field"><label for="_wznd_giftcard_product_categoties"><?php _e('Product categories', 'woocommerce-zc-giftcard'); ?></label>
                <select id="product_categories" name="_wznd_giftcard_product_categoties[]" style="width: 60%;"  class="wc-enhanced-select" multiple="multiple" data-placeholder="<?php esc_attr_e('Any category', 'woocommerce-zc-giftcard'); ?>">
                    <?php
                    $category_ids = (array) get_post_meta($post->ID, '_wznd_giftcard_product_categoties', true);
                    $categories = get_terms('product_cat', 'orderby=name&hide_empty=0');

                    if ($categories) {
                        foreach ($categories as $cat) {
                            echo '<option value="' . esc_attr($cat->term_id) . '"' . selected(in_array($cat->term_id, $category_ids), true, false) . '>' . esc_html($cat->name) . '</option>';
                        }
                    }
                    ?>
                </select> <?php echo wc_help_tip(__('A product must be in this category for the gift card to remain valid or, for "Product Discounts", products in these categories will be discounted.', 'woocommerce-zc-giftcard')); ?>
            </p>
            <p class="form-field"><label for="_wznd_giftcard_exclude_categoties"><?php _e('Exclude categories', 'woocommerce-zc-giftcard'); ?></label>
                <select id="exclude_product_categories" name="_wznd_giftcard_exclude_categoties[]" style="width: 60%;"  class="wc-enhanced-select" multiple="multiple" data-placeholder="<?php esc_attr_e('No categories', 'woocommerce-zc-giftcard'); ?>">
                    <?php
                    $category_ids = (array) get_post_meta($post->ID, '_wznd_giftcard_exclude_categoties', true);
                    $categories = get_terms('product_cat', 'orderby=name&hide_empty=0');

                    if ($categories) {
                        foreach ($categories as $cat) {
                            echo '<option value="' . esc_attr($cat->term_id) . '"' . selected(in_array($cat->term_id, $category_ids), true, false) . '>' . esc_html($cat->name) . '</option>';
                        }
                    }
                    ?>
                </select> <?php echo wc_help_tip(__('Product must not be in this category for the gift card to remain valid or, for "Product Discounts", products in these categories will not be discounted.', 'woocommerce-zc-giftcard')); ?>
            </p>
        </div>
        <div class='options_group'>
            <?php
            woocommerce_wp_checkbox(
                    array(
                        'id' => '_wznd_giftcard_allow_send_date',
                        'label' => __('Show Schedule Date', 'woocommerce-zc-giftcard'),
                        'description' => __('Allow Buyers to specify when to send their gift cards.', 'woocommerce-zc-giftcard')
            ));
            woocommerce_wp_text_input(array(
                'id' => '_wznd_giftcard_coupon_pattern',
                'label' => __('Gift Card Code Pattern', 'woocommerce-zc-giftcard'),
                'style' => 'width:60%',
                'data_type' => 'text',
                'desc_tip' => true,
                'description' => __('Code pattern to use when creating new gift card coupon, (e.g [A10], [Aa10], [a10], [C10], [Cc10], [c10], [N10])', 'woocommerce-zc-giftcard'),
                'placeholder' => 'Use Default'
            ));
            ?>
        </div>
        <div class='options_group'>
            <?php
            woocommerce_wp_select(
                    array(
                        'id' => '_wznd_giftcard_email_template',
                        'label' => __('Gift Card Email Template', 'woocommerce-zc-giftcard'),
                        'class' => 'wc-enhanced-select',
                        'style' => 'width:60%',
                        'options' => WooZndUtil::GetPostTypeOption('wznd_giftcard', 'publish', array('' => __('Default', 'woocommerce-zc-giftcard'))),
                        'desc_tip' => true,
                        'description' => __('Gift card template to use when sending mail.', 'woocommerce-zc-giftcard')
                    )
            );

            woocommerce_wp_select(
                    array(
                        'id' => '_wznd_giftcard_template',
                        'label' => __('Gift Card PDF Template', 'woocommerce-zc-giftcard'),
                        'class' => 'wc-enhanced-select',
                        'style' => 'width:60%',
                        'options' => WooZndUtil::GetPostTypeOption('wznd_giftcard'),
                        'desc_tip' => true,
                        'description' => __('Gift card template to use when sending mail.', 'woocommerce-zc-giftcard')
                    )
            );
            ?>
        </div>
        <div class='options_group'><?php
            woocommerce_wp_select(
                    array(
                        'id' => '_wznd_giftcard_delivery',
                        'label' => __('Delivery Method', 'woocommerce-zc-giftcard'),
                        'class' => 'wc-enhanced-select',
                        'style' => 'width:60%',
                        'options' => [
                            '' => __('Select', 'woocommerce-zc-giftcard'),
                            ZND_GIFTCARD_DELIVERY_OFFLINE => __('Print & Send', 'woocommerce-zc-giftcard'),
                            ZND_GIFTCARD_DELIVERY_SHIP => __('Shipping', 'woocommerce-zc-giftcard'),
                            ZND_GIFTCARD_DELIVERY_EMAIL => __('Email Address', 'woocommerce-zc-giftcard')
                        ],
                        'desc_tip' => true,
                        'description' => __('Delivery method to use after creating a gift card.', 'woocommerce-zc-giftcard')
                    )
            );
            woocommerce_wp_checkbox(array(
                'id' => '_wznd_giftcard_show_sender_name',
                'label' => __('Buyer name field', 'woocommerce-zc-giftcard'),
                'desc_tip' => true,
                'description' => __('Allows buyers to specify their name', 'woocommerce-zc-giftcard'),
            ));
            woocommerce_wp_checkbox(array(
                'id' => '_wznd_giftcard_show_sender_email',
                'label' => __('Buyer email field', 'woocommerce-zc-giftcard'),
                'desc_tip' => true,
                'description' => __('Allows buyers to specify their email', 'woocommerce-zc-giftcard'),
            ));

            woocommerce_wp_checkbox(array(
                'id' => '_wznd_giftcard_show_receiver_name',
                'label' => __('Receiver name field', 'woocommerce-zc-giftcard'),
                'desc_tip' => true,
                'default' => 'yes',
                'description' => __("Allows buyers to specify receiver's email", "woocommerce"),
            ));

            woocommerce_wp_checkbox(array(
                'id' => '_wznd_giftcard_show_receiver_email',
                'label' => __('Receiver email field', 'woocommerce-zc-giftcard'),
                'desc_tip' => true,
                'description' => __("Allows buyers to specify receiver's email", "woocommerce"),
            ));
            woocommerce_wp_checkbox(array(
                'id' => '_wznd_giftcard_show_message',
                'label' => __('Message field', 'woocommerce-zc-giftcard'),
                'desc_tip' => true,
                'description' => __("Allows buyers to add gift card message", "woocommerce"),
            ));
            ?></div>
    </div><?php
        }

        add_action('woocommerce_process_product_meta', 'wooznd_save_giftcard_option_fields');

        function wooznd_save_giftcard_option_fields($post_id) {
//            if (WooZndUtil::GetOption('enable_giftcard', 'yes') == 'no') {
//                return;
//            }

            $is_valid_nonce = ( isset($_POST['wznd_giftcard_nonce']) && wp_verify_nonce($_POST['wznd_giftcard_nonce'], basename(__FILE__)) ) ? 'true' : 'false';
            if (!$is_valid_nonce) {
                return;
            }
            $enable_gift_card = isset($_POST['_wznd_enable_giftcard']) ? 'yes' : 'no';
            update_post_meta($post_id, '_wznd_enable_giftcard', $enable_gift_card);




            if (isset($_POST['_wznd_giftcard_discount_type'])) {
                update_post_meta($post_id, '_wznd_giftcard_discount_type', $_POST['_wznd_giftcard_discount_type']);
            } else {
                delete_post_meta($post_id, '_wznd_giftcard_discount_type');
            }

            if (isset($_POST['_wznd_giftcard_price_type'])) {
                update_post_meta($post_id, '_wznd_giftcard_price_type', $_POST['_wznd_giftcard_price_type']);
            } else {
                delete_post_meta($post_id, '_wznd_giftcard_price_type');
            }

            $wznd_giftcard_from_price = isset($_POST['_wznd_giftcard_from_price']) ? abs($_POST['_wznd_giftcard_from_price']) : 0;
            update_post_meta($post_id, '_wznd_giftcard_from_price', $wznd_giftcard_from_price);

            $wznd_giftcard_to_price = isset($_POST['_wznd_giftcard_to_price']) ? abs($_POST['_wznd_giftcard_to_price']) : 9999999999;
            update_post_meta($post_id, '_wznd_giftcard_to_price', $wznd_giftcard_to_price);

            $wznd_giftcard_select_price = isset($_POST['_wznd_giftcard_select_price']) ? $_POST['_wznd_giftcard_select_price'] : 0;
            update_post_meta($post_id, '_wznd_giftcard_select_price', $wznd_giftcard_select_price);

            $wznd_giftcard_expiry_days = isset($_POST['_wznd_giftcard_expiry_days']) ? absint($_POST['_wznd_giftcard_expiry_days']) : 7;
            $wznd_giftcard_expiry_days = ($wznd_giftcard_expiry_days == 0 || $wznd_giftcard_expiry_days == '') ? 7 : $wznd_giftcard_expiry_days;
            update_post_meta($post_id, '_wznd_giftcard_expiry_days', $wznd_giftcard_expiry_days);

            if (isset($_POST['_wznd_giftcard_product_ids'])) {
//                print_r($_POST['_wznd_giftcard_product_ids']);
//                exit;
                update_post_meta($post_id, '_wznd_giftcard_product_ids', $_POST['_wznd_giftcard_product_ids']);
            } else {
                delete_post_meta($post_id, '_wznd_giftcard_product_ids');
            }


            if (isset($_POST['_wznd_giftcard_exclude_product_ids'])) {
                update_post_meta($post_id, '_wznd_giftcard_exclude_product_ids', $_POST['_wznd_giftcard_exclude_product_ids']);
            } else {
                delete_post_meta($post_id, '_wznd_giftcard_exclude_product_ids');
            }

            if (isset($_POST['_wznd_giftcard_product_categoties'])) {
                update_post_meta($post_id, '_wznd_giftcard_product_categoties', $_POST['_wznd_giftcard_product_categoties']);
            } else {
                delete_post_meta($post_id, '_wznd_giftcard_product_categoties');
            }

            if (isset($_POST['_wznd_giftcard_exclude_categoties'])) {
                update_post_meta($post_id, '_wznd_giftcard_exclude_categoties', $_POST['_wznd_giftcard_exclude_categoties']);
            } else {
                delete_post_meta($post_id, '_wznd_giftcard_exclude_categoties');
            }

            $show_gift_card_date = isset($_POST['_wznd_giftcard_allow_send_date']) ? 'yes' : 'no';
            update_post_meta($post_id, '_wznd_giftcard_allow_send_date', $show_gift_card_date);

            if (isset($_POST['_wznd_giftcard_template'])) {
                update_post_meta($post_id, '_wznd_giftcard_template', $_POST['_wznd_giftcard_template']);
            } else {
                delete_post_meta($post_id, '_wznd_giftcard_template');
            }

            if (isset($_POST['_wznd_giftcard_email_template'])) {
                update_post_meta($post_id, '_wznd_giftcard_email_template', $_POST['_wznd_giftcard_email_template']);
            } else {
                delete_post_meta($post_id, '_wznd_giftcard_email_template');
            }

            if (isset($_POST['_wznd_giftcard_coupon_pattern'])) {
                update_post_meta($post_id, '_wznd_giftcard_coupon_pattern', $_POST['_wznd_giftcard_coupon_pattern']);
            } else {
                delete_post_meta($post_id, '_wznd_giftcard_coupon_pattern');
            }


            if (isset($_POST['_wznd_giftcard_delivery'])) {
                update_post_meta($post_id, '_wznd_giftcard_delivery', $_POST['_wznd_giftcard_delivery']);
            } else {
                delete_post_meta($post_id, '_wznd_giftcard_delivery');
            }

            $giftcard_show_sender_name = isset($_POST['_wznd_giftcard_show_sender_name']) ? 'yes' : 'no';
            update_post_meta($post_id, '_wznd_giftcard_show_sender_name', $giftcard_show_sender_name);

            $giftcard_show_sender_email = isset($_POST['_wznd_giftcard_show_sender_email']) ? 'yes' : 'no';
            update_post_meta($post_id, '_wznd_giftcard_show_sender_email', $giftcard_show_sender_email);

            $giftcard_show_receiver_name = isset($_POST['_wznd_giftcard_show_receiver_name']) ? 'yes' : 'no';
            update_post_meta($post_id, '_wznd_giftcard_show_receiver_name', $giftcard_show_receiver_name);
            
            $giftcard_show_receiver_email = isset($_POST['_wznd_giftcard_show_receiver_email']) ? 'yes' : 'no';
            update_post_meta($post_id, '_wznd_giftcard_show_receiver_email', $giftcard_show_receiver_email);
            
            $giftcard_show_message = isset($_POST['_wznd_giftcard_show_message']) ? 'yes' : 'no';
            update_post_meta($post_id, '_wznd_giftcard_show_message', $giftcard_show_message);
        }
        