<?php

add_action('woocommerce_init', 'ws_giftcard_upgrade_database', 1);

function ws_giftcard_upgrade_database() {

    $giftcard_version = WooZndUtil::GetOption('ws_giftcard_db', 99);
    //Add create Database here.

    if ($giftcard_version < 100) {
        ws_giftcard_upgrade_database100();
    }
    if ($giftcard_version < 101) {
        ws_giftcard_upgrade_database101();
    }
}

function ws_giftcard_upgrade_database100() {
    global $wpdb;
    $charset_collate = $wpdb->get_charset_collate();
    $sql = "CREATE TABLE {$wpdb->prefix}wooznd_giftcard_items ("
            . "id bigint(20) UNSIGNED NOT NULL,"
            . "coupon_id bigint(20) UNSIGNED NOT NULL,"
            . "amount decimal(10,0) NOT NULL,"
            // . "delivery_method tinyint(4) UNSIGNED NULL,"
            . "to_name varchar(256) NOT NULL,"
            . "to_email varchar(256) NOT NULL,"
            . "message varchar(512) NOT NULL,"
            . "from_name varchar(256) NOT NULL,"
            . "from_email varchar(256) NOT NULL,"
            // . "email_template_id bigint(20) UNSIGNED DEFAULT NULL,"
            . "giftcard_template_id bigint(20) UNSIGNED NOT NULL,"
            . "send_date timestamp NULL DEFAULT NULL,"
            . "expiry_date timestamp NULL DEFAULT NULL,"
            . "status tinyint(4) UNSIGNED NOT NULL,"
            . "PRIMARY KEY (id),"
            . "UNIQUE KEY coupon_id (coupon_id)"
            . ") $charset_collate;";

    WooZndUtil::CreateTable($sql);

    WooZndUtil::UpdateOption('ws_giftcard_db', 100);


    $page_definitions = array(
        'card-template-one' => array(
            'title' => __('Card Template One', 'personalize-login'),
            'content' => '<table border="0" width="100%" cellspacing="0">
<tbody>
<tr>
<td class="logo_row" style="height: 90px; padding-top: 20px;" colspan="2" align="center"><img class="alignnone size-full wp-image-372" src="http://codecanyon.meda-pc.com/wp-content/uploads/2017/05/fontawsome_magnet.png" alt="" width="52" height="52" /></td>
</tr>
<tr>
<td style="text-align: center; color: #272727; font-size: 40px;" colspan="2">[wznd_amount]</td>
</tr>
<tr>
<td style="text-align: center; height: 80px; color: #272727; font-size: 24px;" colspan="2">Expire on [wznd_expirydate]</td>
</tr>
<tr>
<td style="text-align: center; color: #272727; font-size: 40px; height: 60px;" colspan="2">COUPON CODE</td>
</tr>
<tr>
<td style="background-color: #f2e900; padding: 20px; text-align: center; color: #272727; font-size: 35px;" colspan="2">[wznd_coupon]</td>
</tr>
<tr style="background-color: #f6f6f6; width: 100%;">
<td style="background-color: #f6f6f6; width: 300px; vertical-align: top;"><img class="alignnone wp-image-373 size-full" src="http://codecanyon.meda-pc.com/wp-content/uploads/2017/05/unsplash_giftcard_happy_bg.png" alt="" width="400" height="365" /></td>
<td style="background-color: #f6f6f6; vertical-align: top; padding: 30px 40px;">[wznd_message]</td>
</tr>
<tr>
<td style="width: 100%; background-color: #fff; padding: 20px; color: #272727; font-size: 24px; text-align: center;" colspan="2">[wznd_barcode]</td>
</tr>
</tbody>
</table>',
            'custom_css' => 'table{
padding:0px;
width:100%;
margin:0px;
border-spacing:0px;
border-collapse:collapse;
}
td{
margin:0px;
}'
        ),
    );

    foreach ($page_definitions as $slug => $page) {
        // Check that the page doesn't exist already
        $query = new WP_Query(array('post_type' => 'wznd_giftcard', 'name' => $slug));
        if (!$query->have_posts()) {
            // Add the page using the data from the array above

            $post_id = wp_insert_post(
                    array(
                        'post_content' => $page['content'],
                        'post_name' => $slug,
                        'post_title' => $page['title'],
                        'post_status' => 'publish',
                        'post_type' => 'wznd_giftcard',
                        'ping_status' => 'closed',
                        'comment_status' => 'closed',
                    )
            );
            if ($post_id > 0) {
                update_post_meta($post_id, '_wznd_giftcard_custom_css', $page['custom_css']);
            }
        }
    }
}

function ws_giftcard_upgrade_database101() {
    global $wpdb;
    ob_start();
    try {
        $col_delivery_method = "ALTER TABLE {$wpdb->prefix}wooznd_giftcard_items ADD delivery_method tinyint(4) UNSIGNED NULL";
        $wpdb->query($col_delivery_method);
        $col_email_template_id = "ALTER TABLE {$wpdb->prefix}wooznd_giftcard_items ADD email_template_id bigint(20) UNSIGNED DEFAULT NULL";
        $wpdb->query($col_email_template_id);
        WooZndUtil::UpdateOption('ws_giftcard_db', 101);
    } catch (Exception $ex) {
        
    }

    ob_get_clean();
}
