<?php include 'refunds-list-inc.php'; ?>
<div class="wrap woo_wallet">
    <h1 class="wp-heading-inline"><?php echo __('Refund Requests', 'woocommerce-zc-refund'); ?></h1>

    <hr class="wp-header-end">
    <h2 class="screen-reader-text"><?php echo __('Filter account list', 'woocommerce-zc-refund'); ?></h2>
    <ul class="subsubsub">
        <li><a href="<?php echo admin_url('admin.php?page=wznd-wallet-refunds'); ?>" class="<?php echo (empty($status) || $status == -1) ? 'current' : ''; ?>"><?php echo __('All', 'woocommerce-zc-refund'); ?> <span class="count">(<?php echo WooZndRefundDB::GetRequestsCount(); ?>)</span></a> |</li>
        <li><a href="<?php echo admin_url('admin.php?page=wznd-wallet-refunds&status=' . ZND_WALLET_REFUND_REQUEST_PENDING); ?>" class="<?php echo $status == ZND_WALLET_REFUND_REQUEST_PENDING ? 'current' : ''; ?>"><?php echo __('Pending', 'woocommerce-zc-refund'); ?> <span class="count">(<?php echo WooZndRefundDB::GetRequestsCount('', ZND_WALLET_REFUND_REQUEST_PENDING); ?>)</span></a>|</li>
        <li><a href="<?php echo admin_url('admin.php?page=wznd-wallet-refunds&status=' . ZND_WALLET_REFUND_REQUEST_APROVED); ?>" class="<?php echo $status == ZND_WALLET_REFUND_REQUEST_APROVED ? 'current' : ''; ?>"><?php echo __('Refunded', 'woocommerce-zc-refund'); ?> <span class="count">(<?php echo WooZndRefundDB::GetRequestsCount('', ZND_WALLET_REFUND_REQUEST_APROVED); ?>)</span></a></li>
        <li><a href="<?php echo admin_url('admin.php?page=wznd-wallet-refunds&status=' . ZND_WALLET_REFUND_REQUEST_REJECTED); ?>" class="<?php echo $status == ZND_WALLET_REFUND_REQUEST_REJECTED ? 'current' : ''; ?>"><?php echo __('Rejected', 'woocommerce-zc-refund'); ?> <span class="count">(<?php echo WooZndRefundDB::GetRequestsCount('', ZND_WALLET_REFUND_REQUEST_REJECTED); ?>)</span></a></li>
    </ul>
    <form id="posts-filter" method="get" action="<?php echo admin_url('admin.php'); ?>">
        <input type="hidden" name="page" value="wznd-wallet-refunds" />
        <?php
        foreach ($url_options as $key => $value) {
            if (!($key == 'search')) {
                ?>
                <input type="hidden" name="<?php echo esc_attr($key); ?>" value="<?php echo esc_attr($value); ?>" />
                <?php
            }
        }
        ?>
        <div class="tablenav top">
            <div class="alignleft actions"> 
                <input type="search" style="width:250px;" name="search" placeholder="<?php echo __('Order number', 'woocommerce-zc-refund'); ?>" value="<?php echo esc_attr($search); ?>">
                <input type="submit" class="button" value="<?php echo __('Search', 'woocommerce-zc-refund'); ?>">	
            </div>
            <div class="pages">
                <span class="displaying-num"><?php $paging->render_result_count(__('{{from}} to {{to}} of {{total}} items', 'woocommerce-zc-refund')); ?></span>
                <?php $paging->render_links($url_format, 5, $url_options, $default_url, '+'); ?>
            </div>
            <br class="clear">
        </div>
    </form>
    <table class="wp-list-table widefat fixed striped">
        <thead>
            <tr>
                <th style="width:130px;"><b><?php echo __('Order #', 'woocommerce-zc-refund'); ?></b></th>
                <th style="width:140px;"><b><?php echo __('Order Date', 'woocommerce-zc-refund'); ?></b></th>
                <th style="width:140px;"><b><?php echo __('Request Date', 'woocommerce-zc-refund'); ?></b></th>
                <th style="width:100px;"><b><?php echo __('Order Amount', 'woocommerce-zc-refund'); ?></b></th>
                <th style="width:100px;"><b><?php echo __('Req. Amount', 'woocommerce-zc-refund'); ?></b></th>
                <th><b><?php echo __('Reason', 'woocommerce-zc-refund'); ?></b></th>  
                <th style="width:195px;"><b><?php echo __('Actions', 'woocommerce-zc-refund'); ?></b></th>
            </tr>
        </thead>

        <tbody>
            <?php
            foreach ($rows as $row) {
                $order = new WC_Order($row['order_id']);
                $order_date;
                $woo_ver = WC()->version;
                if ($woo_ver < "3.0.0" && $woo_ver < "2.7.0") {
                    $order_date = $order->order_date;
                } else {
                    $order_date = $order->get_date_created()->date('Y-m-d H:i:s');
                }
                ?>
                <tr>
                    <td>#<?php echo esc_html($row['order_id']); ?><a href="<?php echo admin_url('post.php?post=' . absint($row['order_id']) . '&action=edit'); ?>" target="_blank"><?php echo __(' - View Order', 'woocommerce-zc-refund'); ?></a></td>
                    <td><?php echo WooZndUtil::MySQLTimeStampToDataTime($order_date, get_option('date_format') . ' ' . get_option('time_format')); ?></td> 
                    <td><?php echo WooZndUtil::MySQLTimeStampToDataTime($row['request_date'], get_option('date_format') . ' ' . get_option('time_format')); ?></td>
                    <td><?php echo wc_price($order->get_total()); ?></td>
                    <td><?php echo wc_price($row['request_amount']); ?></td>
                    <td><?php echo esc_html($row['reason']); ?></td>
                    <td align="right">
                        <?php
                        if ($row['status'] == ZND_WALLET_REFUND_REQUEST_PENDING) {
                            ?>
                            <form action="" method="post" class="table-action-form">                                 
                                <?php wp_nonce_field($nonce_action, 'wznd_refund_nonce'); ?>
                                <input type="hidden" name="action_name" value="cancel-refund" />
                                <input type="hidden" name="refund_id" value="<?php echo esc_attr($row['order_id']); ?>" />                                
                                <button type="submit" class="button"><?php echo __('Reject', 'woocommerce-zc-refund'); ?></button>
                            </form>
                            <form action="" method="post" class="table-action-form">
                                <?php wp_nonce_field($nonce_action, 'wznd_refund_nonce'); ?>
                                <input type="hidden" name="action_name" value="complete-refund" />
                                <input type="hidden" name="refund_id" value="<?php echo esc_attr($row['order_id']); ?>" />
                                <input type="hidden" name="request_amount" value="<?php echo esc_attr($row['request_amount']-$order->get_total_refunded()); ?>" />
                                <button type="submit" class="button"><?php echo __('Refund', 'woocommerce-zc-refund'); ?></button>
                            </form>
                            <?php
                        } else {
                            ?>
                            <?php
                            if ($row['status'] == ZND_WALLET_REFUND_REQUEST_APROVED) {
                                ?>
                                <a class="button disabled"><?php echo __('Refunded', 'woocommerce-zc-refund'); ?></a>
                                <?php
                            }
                            if ($row['status'] == ZND_WALLET_REFUND_REQUEST_REJECTED) {
                                ?>
                                <a class="button disabled"><?php echo __('Rejected', 'woocommerce-zc-refund'); ?></a>
                                <?php
                            }
                            ?>
                            <?php
                        }
                        ?>
                        <a class="button view-refund"><?php echo __('View', 'woocommerce-zc-refund'); ?></a>
                        <div class="popup-hidden view-refund-template" data-title="<?php echo __('Refund Details', 'woocommerce-zc-refund'); ?>">
                            <?php include 'popup/view-refund.php'; ?>
                        </div>
                    </td>
                </tr>    
                <?php
            }
            ?>
        </tbody>
        <tfoot>
            <tr>
                <th><b><?php echo __('Order #', 'woocommerce-zc-refund'); ?></b></th>
                <th><b><?php echo __('Order Date', 'woocommerce-zc-refund'); ?></b></th>
                <th><b><?php echo __('Request Date', 'woocommerce-zc-refund'); ?></b></th>
                <th><b><?php echo __('Order Amount', 'woocommerce-zc-refund'); ?></b></th>
                <th><b><?php echo __('Req. Amount', 'woocommerce-zc-refund'); ?></b></th>
                <th><b><?php echo __('Reason', 'woocommerce-zc-refund'); ?></b></th>  
                <th><b><?php echo __('Actions', 'woocommerce-zc-refund'); ?></b></th>
            </tr>
        </tfoot>
    </table>
    <div class="tablenav bottom">
        <div class="pages">
            <span class="displaying-num"><?php $paging->render_result_count(__('{{from}} to {{to}} of {{total}} items', 'woocommerce-zc-refund')); ?></span>
            <?php $paging->render_links($url_format, 5, $url_options, $default_url, '+'); ?>
        </div>
        <br class="clear">
    </div>
</div>

