<?php

if (!defined('ABSPATH')) {
    exit;
}


if (!class_exists('WC_WooZndReward')) {

    class WC_WooZndReward {

        public static function init() {
            if (is_admin()) {
                //add settings tab
                add_filter('woocommerce_settings_tabs_array', array(new self(), 'settings_tabs_array'), 50);
                //show settings tab
                add_action('woocommerce_settings_tabs_wooznd_reward', array(new self(), 'show_settings_tab'));
                //save settings tab
                add_action('woocommerce_update_options_wooznd_reward', array(new self(), 'update_settings_tab'));

                //add_filter('plugin_action_links_' . plugin_basename(RW_PLUGIN_MAIN_FILE), array(new self(), 'plugin_settings_links'));
            }
        }

//        public static function plugin_settings_links($links) {
//
//            $settings_link = array(
//                'znd_reward_settings' => '<a href="' . admin_url('admin.php?page=wc-settings&tab=wooznd_reward') . '" title="' . __('View Reward Settings', 'woocommerce-zc-reward') . '">' . __('Reward Settings', 'woocommerce-zc-reward') . '</a>'
//            );
//
//            return array_merge($links, $settings_link);
//        }

        public static function settings_tabs_array($settings_tabs) {
            $settings_tabs['wooznd_reward'] = __('Reward', 'woocommerce-zc-reward');
            return $settings_tabs;
        }

        public static function show_settings_tab() {
            woocommerce_admin_fields(self::get_settings());
        }

        public static function update_settings_tab() {
            woocommerce_update_options(self::get_settings());
        }

        private static function get_settings() {


            $settings = array(
                //---------------
                // Other Samples
                //---------------
                'wooznd_reward_section_title' => array(
                    'name' => __('Purchase Reward Settings', 'woocommerce-zc-reward'),
                    'type' => 'title',
                    'desc' => '',
                    'id' => 'wooznd_reward_section_title'
                ),
                'wooznd_enable_purchase_reward' => array(
                    'title' => __('Enable/Disable', 'woocommerce-zc-reward'),
                    'desc' => __('Enable Purchase Reward', 'woocommerce-zc-reward'),
                    'type' => 'checkbox',
                    'default' => 'yes',
                    'id' => 'wooznd_enable_purchase_reward'
                ),
                'wooznd_purchase_reward_remark' => array(
                    'title' => __('Reward  transactions remark', 'woocommerce-zc-reward'),
                    'type' => "textarea",
                    'default' => 'Purchase Reward',
                    'custom_attributes' => array(
                        'cols' => '40',
                        'rows' => '5'
                    ),
                    'id' => 'wooznd_purchase_reward_remark'
                ),
                'wooznd_purchase_reward_payment_methods' => array(
                    'title' => __('Allowed payment methods', 'woocommerce-zc-reward'),
                    'desc' => __('Choose which payment method can be use for purchase reward, leave this field blank to support all payment methods', 'woocommerce-zc-reward'),
                    'desc_tip' => true,
                    'type' => 'multiselect',                    
                    'default' => '',
                    'class' => 'wc-enhanced-select',
                    'css' => 'min-width:300px;',
                    'options' => WooZndUtil::GetPaymentMethodList(),
                    'id' => 'wooznd_purchase_reward_payment_methods',
                   
                ),
                'wooznd_purchase_reward_payment_method_filter' => array(
                    'title' => __('Payment methods filter', 'woocommerce-zc-reward'),
                    'desc' => __('Limit users to the above list of payment methods', 'woocommerce-zc-reward'),
                    'type' => 'checkbox',
                    'default' => 'no',
                    'id' => 'wooznd_purchase_reward_payment_method_filter'
                ),
                'wooznd_purchase_reward_end' => array(
                    'type' => 'sectionend',
                    'id' => 'wooznd_purchase_reward_end'
                ),
                //Refun Mail Option
                'wooznd_purchase_reward_mail_title' => array(
                    'name' => __('Reward Notification', 'woocommerce-zc-reward'),
                    'type' => 'title',
                    'desc' => '',
                    'id' => 'wooznd_purchase_reward_mail_title'
                ),
                'wooznd_purchase_reward_subject' => array(
                    'name' => __('Email subject', 'woocommerce-zc-reward'),
                    'type' => "text",
                    'default' => 'Purchase reward',
                    'placeholder' => __('Subject', 'woocommerce-zc-reward'),
                    'css' => 'min-width:350px;',
                    'id' => 'wooznd_purchase_reward_subject'
                ),
                'wooznd_purchase_reward_message' => array(
                    'name' => __('Email message', 'woocommerce-zc-reward'),
                    'type' => "textarea",
                    'default' => 'Hi [wznd_wallet_name], <br /> Your wallet has been credited with [wznd_trans_credit] for purchasing [wznd_product_link], your new wallet balance is [wznd_wallet_current].',
                    'placeholder' => __('Message', 'woocommerce-zc-reward'),
                    'css' => 'min-width:350px; min-height:200px;',
                    'id' => 'wooznd_purchase_reward_message'
                ),
                'wooznd_reward_section_end' => array(
                    'type' => 'sectionend',
                    'id' => 'wooznd_reward_section_end'
                )
            );
            return $settings;
        }

    }

    WC_WooZndReward::init();
}

