<?php

if (!defined('ABSPATH')) {
    exit;
}


if (!class_exists('WC_WooZndWallet')) {

    class WC_WooZndWallet {

        public static function init() {
            if (is_admin()) {
                //add settings tab
                add_filter('woocommerce_settings_tabs_array', array(new self(), 'settings_tabs_array'), 50);
                //show settings tab
                add_action('woocommerce_settings_tabs_wooznd_wallet', array(new self(), 'show_settings_tab'));
                //save settings tab
                add_action('woocommerce_update_options_wooznd_wallet', array(new self(), 'update_settings_tab'));

//                add_filter('plugin_action_links_' . plugin_basename(WL_PLUGIN_MAIN_FILE), array(new self(), 'plugin_settings_links'));
            }
        }

//        public static function plugin_settings_links($links) {
//
//            $settings_link = array(
//                'znd_wallet_settings' => '<a href="' . admin_url('admin.php?page=wc-settings&tab=wooznd_wallet') . '" title="' . __('View Wallet Settings', 'smartpack') . '">' . __('Wallet Settings', 'smartpack') . '</a>'
//            );
//
//            return array_merge($links, $settings_link);
//        }

        public static function settings_tabs_array($settings_tabs) {
            $settings_tabs['wooznd_wallet'] = __('Wallet', 'smartpack');
            return $settings_tabs;
        }

        public static function show_settings_tab() {
            woocommerce_admin_fields(self::get_settings());
        }

        public static function update_settings_tab() {

            if (isset($_POST['wooznd_deposit_product_id'])) {
                WooZndUtil::UpdateOption('deposit_product_id', $_POST['wooznd_deposit_product_id']);
            } else {
                delete_option('wooznd_deposit_product_id');
            }

            woocommerce_update_options(self::get_settings());
        }

        private static function get_settings() {
            $args = array(
                'role' => 'administrator',
                'orderby' => 'meta_key=first_name',
                'order' => 'ASC',
                'fields' => array('id', 'user_login')
            );

            $admin_users_db = (new WP_User_Query($args))->get_results();
            $admin_users = array();

            foreach ($admin_users_db as $user) {
                $admin_users[$user->id] = $user->user_login;
            }
            $deposit_p = array();

            $prod = WooZndUtil::GetOption('deposit_product_id', 0);
            if ($prod > 0) {
                $deposit_p = array(
                    $prod => WooZndUtil::GetFormattedProductName($prod, false)
                );
            }

            $d_prod = array(
                'name' => __('Deposit product', 'smartpack'),
                'type' => "select",
                'class' => 'wc-product-search',
                'desc' => __('Select a product to use for funds deposit', 'smartpack'),
                'desc_tip' => true,
                'placeholder' => __('Search for a product&hellip;', 'smartpack'),
                'custom_attributes' => array(
                    'data-placeholder' => __('Search for a product&hellip;', 'smartpack'),
                    'data-selected' => WooZndUtil::GetFormattedProductName(WooZndUtil::GetOption('deposit_product_id', 0), false),
                ),
                'options' => $deposit_p,
                'id' => 'wooznd_deposit_product_id'
            );
            $woo_ver = WC()->version;
            if ($woo_ver < "3.0.0" && $woo_ver < "2.7.0") {
                $d_prod = array(
                    'name' => __('Deposit product', 'smartpack'),
                    'type' => "text",
                    'class' => 'wc-product-search',
                    'desc' => __('Select a product to use for funds deposit', 'smartpack'),
                    'desc_tip' => true,
                    'custom_attributes' => array(
                        'data-multiple' => 'false',
                        'data-placeholder' => __('Search for a product&hellip;', 'smartpack'),
                        'data-action' => 'woocommerce_json_search_products_and_variations',
                        'data-selected' => WooZndUtil::GetFormattedProductName(WooZndUtil::GetOption('deposit_product_id', 0), false),
                    ),
                    'id' => 'wooznd_deposit_product_id'
                );
            }

            $settings = array(
                //---------------
                // Wallet Settings
                //---------------
                'wooznd_wallet_section_title' => array(
                    'name' => __('Wallet Settings', 'smartpack'),
                    'type' => 'title',
                    'desc' => '',
                    'id' => 'wooznd_wallet_section_title'
                ),
                'wooznd_auto_create_new_wallet' => array(
                    'title' => __('Auto create wallet', 'smartpack'),
                    'desc' => __('Automatically create new wallet for users', 'smartpack'),
                    'desc_tip' => true,
                    'type' => 'checkbox',
                    'default' => 'yes',
                    'id' => 'wooznd_auto_create_new_wallet'
                ),
                'wooznd_wallet_account_number_start' => array(
                    'title' => __('Account number start from', 'smartpack'),
                    'type' => "text",
                    'css' => 'min-width:350px;',
                    'id' => 'wooznd_wallet_account_number_start'
                ),
                'wooznd_new_wallet_remark' => array(
                    'title' => __('New wallet remark', 'smartpack'),
                    'type' => "text",
                    'default' => 'New Account',
                    'css' => 'min-width:350px;',
                    'id' => 'wooznd_new_wallet_remark'
                ),
                'wooznd_transactions_receipt_format' => array(
                    'title' => __('Receipt number format', 'smartpack'),
                    'type' => "text",
                    'desc' => __('You can use the following variables: {{account_number}} and {{transaction_id}}', 'smartpack'),
                    'desc_tip' => true,
                    'default' => 'TRX{{account_number}}{{transaction_id}}',
                    'css' => 'min-width:350px;',
                    'id' => 'wooznd_transactions_receipt_format'
                ),
                'wooznd_basicsettings_end' => array(
                    'type' => 'sectionend',
                    'id' => 'wooznd_basicsettings_end'
                ),
//                //My-Wallet Page Settings
//                 'wooznd_mywalletpage_section_title' => array(
//                    'name' => __('My Wallet Page', 'smartpack'),
//                    'type' => 'title',
//                    'desc' => '',
//                    'id' => 'wooznd_mywalletpage_section_title'
//                ),
//                'wooznd_mywallet_wallet' => array(
//                    'title' => __('Show/Hide', 'smartpack'),
//                    'desc' => __('Show or Hide My wallet Page', 'smartpack'),
//                    'desc_tip' => true,
//                    'type' => 'checkbox',
//                    'default' => 'yes',
//                    'id' => 'wooznd_mywallet_wallet'
//                ),
//                'wooznd_mywalletsettings_end' => array(
//                    'type' => 'sectionend',
//                    'id' => 'wooznd_mywalletsettings_end'
//                ),
                //Funds Deposit
                'wooznd_funds_deposit_title' => array(
                    'name' => __('Funds Deposit', 'smartpack'),
                    'type' => 'title',
                    'desc' => '',
                    'id' => 'wooznd_funds_deposit_title'
                ),
                'wooznd_deposit_product_id' => $d_prod,
                'wooznd_make_deposit_on_order_status' => array(
                    'title' => __('Complete deposit on order status change', 'smartpack'),
                    'desc' => __('Choose when to make complete deposit order', 'smartpack'),
                    'desc_tip' => true,
                    'type' => 'select',
                    'default' => 'processing',
                    'class' => 'wc-enhanced-select',
                    'css' => 'min-width:300px;',
                    'options' => array(
                        'on-hold' => __('On-Hold', 'smartpack'),
                        'processing' => __('Processing', 'smartpack'),
                        'completed' => __('Completed', 'smartpack'),
                    ),
                    'id' => 'wooznd_make_deposit_on_order_status'
                ),
                'wooznd_wallet_deposit_remark' => array(
                    'title' => __('Deposit remark', 'smartpack'),
                    'type' => "text",
                    'default' => 'Funds Deposit',
                    'css' => 'min-width:350px;',
                    'id' => 'wooznd_wallet_deposit_remark'
                ),
                'wooznd_deposit_payment_methods' => array(
                    'title' => __('Payment methods', 'smartpack'),
                    'desc' => __('Choose which payment method can be use for funds deposit, leave this field blank to support all payment methods', 'smartpack'),
                    'desc_tip' => true,
                    'type' => 'multiselect',
                    'default' => '',
                    'class' => 'wc-enhanced-select',
                    'css' => 'min-width:300px;',
                    'options' => WooZndUtil::GetPaymentMethodList(),
                    'id' => 'wooznd_deposit_payment_methods',
                ),
                'wooznd_funds_deposit_end' => array(
                    'type' => 'sectionend',
                    'id' => 'wooznd_funds_deposit_end'
                ),
                //New Wallets Reward
                'wooznd_partial_payment_title' => array(
                    'name' => __('Partial Payment', 'smartpack'),
                    'type' => 'title',
                    'desc' => '',
                    'id' => 'wooznd_partial_payment_title'
                ),
                'wooznd_enable_wallet_partial_payment' => array(
                    'title' => __('Enable/Disable', 'smartpack'),
                    'desc' => __('Enable partial payment', 'smartpack'),
                    'desc_tip' => true,
                    'type' => 'checkbox',
                    'default' => 'no',
                    'id' => 'wooznd_enable_wallet_partial_payment'
                ),
                'wooznd_wallet_partial_payment_text' => array(
                    'title' => __('Cart text', 'smartpack'),
                    'type' => "text",
                    'default' => 'Wallet Funds',
                    'css' => 'min-width:350px;',
                    'id' => 'wooznd_wallet_partial_payment_text'
                ),
                'wooznd_wallet_partial_payment_min' => array(
                    'title' => __('Wallet funds threshold', 'smartpack'),
                    'type' => "number",
                    'default' => '0',
                    'desc' => __('Controls the minimum wallet balance for partial payment to apply on cart', 'smartpack'),
                    'desc_tip' => true,
                    'css' => 'min-width:350px;',
                    'custom_attributes' => array(
                        'min' => '0',
                        'step' => '1'
                    ),
                    'id' => 'wooznd_wallet_partial_payment_min'
                ),
                'wooznd_make_partial_payment_on_order_status' => array(
                    'title' => __('Complete payment on order status change', 'smartpack'),
                    'desc' => __('Choose when to make complete partial payment order', 'smartpack'),
                    'desc_tip' => true,
                    'type' => 'select',
                    'default' => 'on-hold',
                    'class' => 'wc-enhanced-select',
                    'css' => 'min-width:300px;',
                    'options' => array(
                        'completed' => __('Completed', 'smartpack'),
                        'processing' => __('Processing', 'smartpack'),
                        'on-hold' => __('On-Hold', 'smartpack'),
                    ),
                    'id' => 'wooznd_make_partial_payment_on_order_status'
                ),
                'wooznd_wallet_partial_payment_remark' => array(
                    'title' => __('Payment remark', 'smartpack'),
                    'type' => "text",
                    'default' => 'Partial Payment',
                    'css' => 'min-width:350px;',
                    'id' => 'wooznd_wallet_partial_payment_remark'
                ),
                'wooznd_show_wallet_partial_payment_box' => array(
                    'title' => __('Show partial payment box', 'smartpack'),
                    'desc' => __('Allows users to choose when to apply partial payment on their cart.', 'smartpack'),
                    'desc_tip' => true,
                    'type' => 'checkbox',
                    'default' => 'no',
                    'id' => 'wooznd_show_wallet_partial_payment_box'
                ),
                'wooznd_wallet_partial_payment_box_title' => array(
                    'title' => __('Partial payment box title', 'smartpack'),
                    'type' => "text",
                    'default' => 'Partial Payment',
                    'css' => 'min-width:350px;',
                    'id' => 'wooznd_wallet_partial_payment_box_title'
                ),
                'wooznd_wallet_partial_payment_box_desc' => array(
                    'title' => __('Partial payment box description', 'smartpack'),
                    'type' => "textarea",
                    'default' => 'Use the {{funds}} available funds in my wallet',
                    'css' => 'min-width:350px;',
                    'custom_attributes' => array(
                        'cols' => '40',
                        'rows' => '2'
                    ),
                    'id' => 'wooznd_wallet_partial_payment_box_desc'
                ),
                'wooznd_wallet_partial_payment_box_label' => array(
                    'title' => __('Partial payment box checkbox text', 'smartpack'),
                    'type' => "text",
                    'default' => 'Use my wallet funds',
                    'css' => 'min-width:350px;',
                    'id' => 'wooznd_wallet_partial_payment_box_label'
                ),
                'wooznd_partial_payment_methods' => array(
                    'title' => __('Allowed payment methods', 'smartpack'),
                    'desc' => __('Choose which payment method can be use with partial payment, leave this field blank to support all payment methods', 'smartpack'),
                    'desc_tip' => true,
                    'type' => 'multiselect',
                    'default' => '',
                    'class' => 'wc-enhanced-select',
                    'css' => 'min-width:300px;',
                    'options' => WooZndUtil::GetPaymentMethodList(),
                    'id' => 'wooznd_partial_payment_methods',
                ),
                'wooznd_partial_payment_end' => array(
                    'type' => 'sectionend',
                    'id' => 'wooznd_partial_payment_end'
                ),
                //New Wallets Reward
                'wooznd_new_wallet_title' => array(
                    'name' => __('New Wallet Reward', 'smartpack'),
                    'type' => 'title',
                    'desc' => '',
                    'id' => 'wooznd_new_wallet_title'
                ),
                'wooznd_new_wallet_freecredit' => array(
                    'name' => __('Reward amount', 'smartpack'),
                    'type' => "number",
                    'default' => '0',
                    'desc' => __('Amount to credit every new wallet', 'smartpack'),
                    'desc_tip' => true,
                    'placeholder' => __('Reward amount', 'smartpack'),
                    'custom_attributes' => array(
                        'min' => '0',
                    ),
                    'css' => 'min-width:350px;',
                    'id' => 'wooznd_new_wallet_freecredit'
                ),
                'wooznd_new_wallet_freecredit_remark' => array(
                    'title' => __('Reward remark', 'smartpack'),
                    'type' => "textarea",
                    'default' => 'free',
                    'css' => 'min-width:350px;',
                    'custom_attributes' => array(
                        'cols' => '40',
                        'rows' => '2'
                    ),
                    'id' => 'wooznd_new_wallet_freecredit_remark'
                ),
                'wooznd_new_wallet_freecredit_status' => array(
                    'title' => __('Reward transaction status', 'smartpack'),
                    'type' => 'select',
                    'default' => ZND_WALLET_TRANSANCTION_STATUS_PENDING,
                    'class' => 'wc-enhanced-select',
                    'css' => 'min-width:300px;',
                    'options' => array(
                        ZND_WALLET_TRANSANCTION_STATUS_PENDING => WalletUtil::TransactionStatusString(ZND_WALLET_TRANSANCTION_STATUS_PENDING, false),
                        ZND_WALLET_TRANSANCTION_STATUS_ONHOLD => WalletUtil::TransactionStatusString(ZND_WALLET_TRANSANCTION_STATUS_ONHOLD, false),
                        ZND_WALLET_TRANSANCTION_STATUS_PROCESSING => WalletUtil::TransactionStatusString(ZND_WALLET_TRANSANCTION_STATUS_PROCESSING, false),
                        ZND_WALLET_TRANSANCTION_STATUS_COMPLETED => WalletUtil::TransactionStatusString(ZND_WALLET_TRANSANCTION_STATUS_COMPLETED, false),
//                        ZND_WALLET_TRANSANCTION_STATUS_CANCELLED => WalletUtil::TransactionStatusString(ZND_WALLET_TRANSANCTION_STATUS_CANCELLED, false),
                    ),
                    'id' => 'wooznd_new_wallet_freecredit_status'
                ),
                'wooznd_new_wallet_end' => array(
                    'type' => 'sectionend',
                    'id' => 'wooznd_new_wallet_end'
                ),
                //Security
                'wooznd_security_title' => array(
                    'name' => __('Wallets Data Security', 'smartpack'),
                    'type' => 'title',
                    'desc' => '',
                    'id' => 'wooznd_security_title'
                ),
                'wooznd_system_id' => array(
                    'title' => __('System user', 'smartpack'),
                    'type' => 'select',
                    'default' => '1',
                    'class' => 'wc-enhanced-select',
                    'css' => 'min-width:300px;',
                    'options' => $admin_users,
                    'id' => 'wooznd_system_id'
                ),
                'wooznd_encryption_key' => array(
                    'title' => __('Encryption key', 'smartpack'),
                    'type' => "text",
                    'default' => WooZndUtil::GetOption('encryption_key', ''),
                    'css' => 'min-width:350px;',
                    'id' => 'wooznd_encryption_key'
                ),
                'wooznd_encryption_key_vi' => array(
                    'title' => __('Encryption key VI', 'smartpack'),
                    'type' => "text",
                    'default' => WooZndUtil::GetOption('encryption_key_vi', ''),
                    'css' => 'min-width:350px;',
                    'id' => 'wooznd_encryption_key_vi'
                ),
                'wooznd_security_end' => array(
                    'type' => 'sectionend',
                    'id' => 'wooznd_security_end'
                ),
                //New Wallet Mail
                'wooznd_new_wallet_mail_title' => array(
                    'name' => __('New Wallet Notification', 'smartpack'),
                    'type' => 'title',
                    'desc' => '',
                    'id' => 'wooznd_purchase_reward_mail_title'
                ),
                'wooznd_new_wallet_mail_subject' => array(
                    'name' => __('Email subject', 'smartpack'),
                    'type' => "text",
                    'default' => 'Your new wallet has been created',
                    'placeholder' => __('Subject', 'smartpack'),
                    'css' => 'min-width:350px;',
                    'id' => 'wooznd_new_wallet_mail_subject'
                ),
                'wooznd_new_wallet_mail_message' => array(
                    'name' => __('Email message', 'smartpack'),
                    'type' => "textarea",
                    'default' => 'Hi [wznd_wallet_name], <br /> Your new wallet has been created, you can deposit any amount into your wallet and later use this funds to purchase product & services on our website.',
                    'placeholder' => __('Message', 'smartpack'),
                    'css' => 'min-width:350px; min-height:200px;',
                    'id' => 'wooznd_new_wallet_mail_message'
                ),
                'wooznd_new_wallet_mail_end' => array(
                    'type' => 'sectionend',
                    'id' => 'wooznd_new_wallet_mail_end'
                ),
                //New Wallet Reward
                'wooznd_wallet_reward_title' => array(
                    'name' => __('New Wallet Reward Notification', 'smartpack'),
                    'type' => 'title',
                    'desc' => '',
                    'id' => 'wooznd_wallet_reward_title'
                ),
                'wooznd_new_wallet_reward_mail_subject' => array(
                    'name' => __('Email subject', 'smartpack'),
                    'type' => "text",
                    'default' => 'New Wallet Reward',
                    'placeholder' => __('Subject', 'smartpack'),
                    'css' => 'min-width:350px;',
                    'id' => 'wooznd_new_wallet_reward_mail_subject'
                ),
                'wooznd_new_wallet_reward_mail_message' => array(
                    'name' => __('Email message', 'smartpack'),
                    'type' => "textarea",
                    'default' => 'Hi [wznd_wallet_name], <br /> Your new wallet has been credited with [wznd_trans_credit] as part of our on going promo, your new wallet balance is [wznd_wallet_current].',
                    'placeholder' => __('Message', 'smartpack'),
                    'css' => 'min-width:350px; min-height:200px;',
                    'id' => 'wooznd_new_wallet_reward_mail_message'
                ),
                'wooznd_new_wallet_reward_mail_end' => array(
                    'type' => 'sectionend',
                    'id' => 'wooznd_new_wallet_reward_mail_end'
                ),
                //Wallet Deposit
                'wooznd_wallet_deposit_title' => array(
                    'name' => __('Funds Deposit Notification', 'smartpack'),
                    'type' => 'title',
                    'desc' => '',
                    'id' => 'wooznd_wallet_reward_title'
                ),
                'wooznd_wallet_deposit_mail_subject' => array(
                    'name' => __('Email subject', 'smartpack'),
                    'type' => "text",
                    'default' => 'New Funds Deposit',
                    'placeholder' => __('Subject', 'smartpack'),
                    'css' => 'min-width:350px;',
                    'id' => 'wooznd_wallet_deposit_mail_subject'
                ),
                'wooznd_wallet_deposit_mail_message' => array(
                    'name' => __('Email message', 'smartpack'),
                    'type' => "textarea",
                    'default' => 'Hi [wznd_wallet_name], <br /> Your wallet has been credited with [wznd_trans_credit] funds deposit, your new wallet balance is [wznd_wallet_current].',
                    'placeholder' => __('Message', 'smartpack'),
                    'css' => 'min-width:350px; min-height:200px;',
                    'id' => 'wooznd_wallet_deposit_mail_message'
                ),
                'wooznd_wallet_deposit_mail_end' => array(
                    'type' => 'sectionend',
                    'id' => 'wooznd_wallet_deposit_mail_end'
                ),
                //Wallet Transaction
                'wooznd_wallet_transaction_title' => array(
                    'name' => __('Transactions Notification', 'smartpack'),
                    'type' => 'title',
                    'desc' => '',
                    'id' => 'wooznd_wallet_transaction_title'
                ),
                'wooznd_wallet_transactions_mail_subject' => array(
                    'name' => __('Email subject', 'smartpack'),
                    'type' => "text",
                    'default' => 'New Transactions: [wznd_trans_receipt]',
                    'placeholder' => __('Subject', 'smartpack'),
                    'css' => 'min-width:350px;',
                    'id' => 'wooznd_wallet_transactions_mail_subject'
                ),
                'wooznd_wallet_transactions_mail_message' => array(
                    'name' => __('Email message', 'smartpack'),
                    'type' => "textarea",
                    'default' => 'Hi [wznd_wallet_name], <br /> A [wznd_trans_type] transaction ([wznd_trans_receipt]) has occured on your wallet, your new wallet balance is [wznd_wallet_current].',
                    'placeholder' => __('Message', 'smartpack'),
                    'css' => 'min-width:350px; min-height:200px;',
                    'id' => 'wooznd_wallet_transactions_mail_message'
                ),
                'wooznd_wallet_transactions_mail_end' => array(
                    'type' => 'sectionend',
                    'id' => 'wooznd_wallet_transactions_mail_end'
                ),
                //Wallet Transaction Status
                'wooznd_wallet_transaction_status_title' => array(
                    'name' => __('Transactions Status Notification', 'smartpack'),
                    'type' => 'title',
                    'desc' => '',
                    'id' => 'wooznd_wallet_transaction_status_title'
                ),
                'wooznd_wallet_transactions_status_mail_subject' => array(
                    'name' => __('Email subject', 'smartpack'),
                    'type' => "text",
                    'default' => 'Transactions [wznd_trans_receipt] status',
                    'placeholder' => __('Subject', 'smartpack'),
                    'css' => 'min-width:350px;',
                    'id' => 'wooznd_wallet_transactions_status_mail_subject'
                ),
                'wooznd_wallet_transactions_status_mail_message' => array(
                    'name' => __('Email message', 'smartpack'),
                    'type' => "textarea",
                    'default' => 'Hi [wznd_wallet_name], <br /> A [wznd_trans_type] transaction ([wznd_trans_receipt]) is now [wznd_trans_status], your new wallet balance is [wznd_wallet_current].',
                    'placeholder' => __('Message', 'smartpack'),
                    'css' => 'min-width:350px; min-height:200px;',
                    'id' => 'wooznd_wallet_transactions_status_mail_message'
                ),
                'wooznd_wallet_section_end' => array(
                    'type' => 'sectionend',
                    'id' => 'wooznd_wallet_section_end'
                )
            );
            return $settings;
        }

    }

    WC_WooZndWallet::init();
}

